import { Text, View } from "@tarojs/components"
import { memo } from "react"
import classnames from "classnames";
import styles  from './index.module.scss'


type Param = {
    status?: 0|1|2 //0默认不处理, 1退款，2退货
}
export default memo(({status = 0}:Param) => {
    return (
        <>
            {(status !== 0)&&<View className={classnames(styles.tag, status == 1?styles.refund_tag :styles.saleReturn_tag)}>
                <View className={classnames(styles.miconfont,  'iconfont icon-yucunkuan')}></View>
                <Text>{ status == 1?'退款':'退货'}</Text>
            </View>}
        </>
    )
})